<%@page import="imagemed.http.IMRequest"%>
<%@page import="java.io.PrintWriter"%>
<%@page import="com.erad.pacs.app.broker.table.TableBrokerFacade"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@
	page errorPage="../main/exceptionHandler.jsp"

%>
<%--
 ** Component: scheduler
 **
 ** Description:
 **   this jsp page is intended to be used in popup windows called by PopupTableInputMacro
 **   
 **
 ** Parameters: 
 **
 **  @param cTable         name of the table to display
 **  @param cJoinPath      list of table names separated by '_' from clause will start with these tables nat joined 
 **                        together followed by cTable 
 **  @param cIDField       name of the field to return
 **  @param cDispField     name of the fields to display
 **  @param cInputID       ID of the input field in the calling form that should be updated with the selected row's ID
 **  @param cAdjustQuery   query string to be passed to caller window's updateOtherFields() function
 **  @param cDoRefresh     refresh caller page after setting the value and adjusting if necessary if "true"
 **  @param cEmbed         this page is used embedded to another one
 **  @param cCallBackFunc  Javascript function to ba called back on value selection
 **  @param cPageTitle     Title for the page
 **  @param cPageBack      Add back button with this URL to the page (when the page is added to a frame)
 **  @param cSelectIcon    Icon to be displayed in selector action to select the item (single select only)
 **  @param cSelectLabel   Label to be displayed in selector action to select the item (single select only)
 **  @param cSelectMessage Label to be displayed in selector action on mouse over the icon or label (single select only)
 **
 ** $Author $
 ** $Date $
 **
 *
 *  RCS File Name    : $RCSfile $
 *  RCS Revision     : $Revision $
 *  Locked by        : $Locker $
 *  Symbolic name    : $Name $
 *  State            : $State $
 --%><%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="com.erad.pacs.common.interfaces.table.FieldManager"%>
<%@page import="imagemed.util.IMProperties"%>
<%@
	page import="imagemed.imsession.*,imagemed.jsputil.*,imagemed.exception.*,java.util.*,
	imagemed.layout.datasource.DBLayoutDataSource,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			com.erad.pacs.common.interfaces.result.*"
	
%><%@
	page errorPage ="../main/exceptionHandler.jsp"
	
%>
<%-- Input Parameters --%><%
UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session is = userManager.getSessitaSession( request, response );

	//Context context = Context.hasContext( request ) ? new Context( is, request ) : null;

	IMRequest imReq = new IMRequest( request, is );
	
	JspSession jspSess = new JspSession(is, request, response, out);
	
	String parLayoutType = imReq.getVal( "cLayoutType" );
	if ( parLayoutType == null || parLayoutType.length() == 0 ) {
		throw new IMException( "The required parameter cLayoutType was not properly filled." );
	}
// 	String[] parTables = parTable.split( ";" );
// 	if ( parTables == null || parTables.length == 0 ) {
// 		throw new IMException( "The required parameter cTable was not properly filled." );
// 	}
	
// 	String parMainTable = parTables[ 0 ];
// 	int listType = parTables.length ==1 ? GenericUserListImpl.getListType4Table( parMainTable ) : -1;
// 	String parJoinPath = imReq.getVal( "cJoinPath", "" );
// 	List<String> joinTables = new ArrayList<String>();
// 	StringTokenizer st = new StringTokenizer( parJoinPath, "_" );
// 	while ( st.hasMoreTokens() ) {
// 		String table = st.nextToken();
// 		if ( table.equals( parMainTable ) ) {
// 	break;
// 		}
// 		joinTables.add( table );
// 	}
	
// 	if ( !joinTables.contains( parMainTable ) ) {
// 		joinTables.add( parMainTable );
// 	}
	List<String> parIDField = Arrays.asList( imReq.getVals( "cIDField" ) );
	if ( parIDField == null || parIDField.size() < 1 || parIDField.get( 0 ).length() == 0 ) {
		throw new IMException( "The required parameter cIDField was not properly filled." );
	}
	String[] parDispField = imReq.getVals( "cDispField" );
	if ( parDispField == null || parDispField.length < 1 || parDispField[0].length() < 1 ) {
		throw new IMException( "The required parameter cDispField was not properly filled." );
	}
	boolean doRefresh = "true".equals( imReq.getVal( "cDoRefresh" ) );
	boolean displayAll = "true".equals( imReq.getVal( "cDisplayAll" ) );
	boolean batchMode = "true".equals( imReq.getVal( "cAddBatch" ) );
	boolean doFiltersFirst = "true".equals( imReq.getVal( "cStartWithFilters" ) );
	String adjustQuery = imReq.getVal( "cAdjustQuery" ); //Helper.decodeByRty()
	String operName = imReq.getVal( "cOperName" );
	String targetField = imReq.getVal( "cTargetField" );
	String parInputID = imReq.getVal( "cInputID" );
	String callBackFunc = imReq.getVal( "cCallBackFunc" );

	String selectIcon = imReq.getVal( "cSelectIcon" );
	String selectLabel = imReq.getVal( "cSelectLabel" );
	String selectMessage = imReq.getVal( "cSelectMessage" );
	
	String pageTitle = imReq.getVal( "cPageTitle" );
	if ( pageTitle == null ) {
		pageTitle = "Selector table";
	}

	String pageBack = imReq.getVal( "cPageBack" );
	
	if ( batchMode ) {
		if ( operName == null || operName.length() < 1 ) {
	throw new IMException( "The required parameter cOperName was not properly filled." );
		}
		if ( targetField == null || targetField.length() < 1 ) {
	throw new IMException( "The required parameter cTargetField was not properly filled." );
		}
	}
	else {
		if ( parInputID == null || parInputID.length() < 1 ) {
	throw new IMException( "The required parameter cInputID was not properly filled." );
		}
	}
	
	if ( !Context.hasContext( request ) ) {
		
		imReq.setProperty( "cSorts", "a_"+parDispField[ 0 ] ); // set default sort
		imReq.setProperty( "cFields", parDispField ); // set default fields
 		// we did not have a context, redirect the page now.
 		response.sendRedirect( "valueSelectorPopupTable.jsp?cContext=" + imReq.backupContext() );
 		return;
	}
 	else {
 		// just save the context
 		imReq.delProperty( "cStartWithFilters" );
 		imReq.save();
	}

	DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( parLayoutType );

	FieldManager fm =  EntryLayoutFactory.getDefaultFieldManager( is, parLayoutType );

	TableDescriptorImpl tdesc = new TableDescriptorImpl( null, true, true, true, false );
	TablePropertiesImpl tprop = new TablePropertiesImpl();


	TableBrokerFacade tb = Connector.getInstance().get( TableBrokerFacade.Caller );

	WorklistTableParamsImpl tparams = new WorklistTableParamsImpl(tb.getListDescriptor(), is);

	tparams.setLayoutType( parLayoutType );
	
	tparams.setDefaultFields( imReq.getVals( "cDispField" ) );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	tparams.setExtraParams( new String[]{ "cTable", "cJoinPath", "cIDField", "cDispField", "cInputID", "cAdjustQuery", "cDoRefresh", "cEmbed", "cCallBackFunc", "cPageTitle", 
	"cPageBack", "cSelectIcon", "cSelectLabel", "cSelectMessage" } );
	tparams.setDefaultPriorityFirst( "false" );
	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );
	
	tparams.setImRequest( imReq );
	
	tparams.initParams( null, true, imReq.toImProps() );

	tdesc.setIndexPage( "/scheduler/valueSelectorPopupTable.jsp" );

	ColumnImpl col = null;
	if ( batchMode ) {
		if ( parIDField.size() != 1 ) {
	throw new RuntimeException( "Batch select mode is not implemented for compound IDs " + Helper.toString( parIDField ) );
		}
		ActionImpl[] batchAct = new ActionImpl[ 1 ];
		batchAct[ 0 ] = new LinkAction( tdesc, null, "JavaScript:callBackParentMulti()", "apply", "Add selected records" );
		ActionImpl checkBoxAction = new CheckboxAction( tprop, parIDField.get( 0 ), "cGr", new String[]{} );
		col = new ColumnImpl( new BatchHeader( batchAct ), new ActionCell( parIDField.get( 0 ), new ActionImpl[]{ checkBoxAction }), parIDField.get( 0 ) );
	}
	else {
		ValueSelectorAction selectorAction = new ValueSelectorAction( tprop, parIDField.get( 0 ), parInputID, displayAll ? parDispField:( new String[]{ parDispField[ 0 ] } ) );
		if ( selectIcon != null ) {
	selectorAction.setSelectIcon( selectIcon, selectMessage );
		}
		else if ( selectLabel != null ) {
	selectorAction.setSelectLabel( selectLabel, selectMessage );
		}
		if ( selectMessage != null ) {
	selectorAction.setSelectMessage( selectMessage );
		}
		
		col = new ColumnImpl( new SimpleHeader( "&nbsp;" ),	new ActionCell( parIDField.get( 0 ),
		new ActionImpl[]{ new MultiAction( tprop, new ActionImpl[]{ selectorAction }) }),
		parIDField.get( 0 ) );
	}
	tdesc.addExtraColumn( "_FIRST", col );
	
	Vector<TopCellImpl> vTopCell = new Vector<TopCellImpl>();
	
	vTopCell.add( new TitleTopCell( tprop, pageTitle ) );
	vTopCell.add( new SeparatorTopCell( tprop, 4 ) );
	
	vTopCell.add( new FieldsTopCell( tdesc, null, false, true ) );
//	FiltersTopCell filtersTopCell = new FiltersTopCell( tdesc, null, false, new String[ 0 ], false, true ); 
//	vTopCell.add( filtersTopCell );
//	vTopCell.add( new SortsTopCell( tdesc, null, false, false ) );
	
	if ( pageBack != null ) {
		Properties prpTD = new Properties();
		prpTD.setProperty( "align", "right" );
		prpTD.setProperty( "width", "40%" );
		vTopCell.add( new SimpleTopCell( tprop, "<a href=\"" + pageBack +
		"\"><script>getButtonFull(\"backButton\", 24, 24, \"\");</script></a>", prpTD ) );
	}
	
	vTopCell.add( new PageTopCell( tprop, tparams ) );
	tdesc.setTopCells( vTopCell.toArray( new TopCellImpl [ 0 ] ) );

	// --- Init TableImpl with Result ---
	DBLDSWrapperNatSqlResultImpl result = new DBLDSWrapperNatSqlResultImpl( tdesc, dblds, is.getUser(), DBLDSWrapperNatSqlResultImpl.SQL_11_MODE );
	result.setRequiredFields( parDispField );
	tdesc.setResult( result );
	TableImpl table = new TableImpl( tdesc );
%>
<%@page import="imagemed.layout.datasource.EntryLayoutFactory"%>
<%@page import="imagemed.layout.datasource.LayoutDescriptor"%>
<%@page import="imagemed.layout.macro.input.ForeignIDInputMacro"%>
<%@page import="imagemed.layout.datasource.pointer.FieldPointer"%>
<%@page import="imagemed.util.Helper"%><HTML><HEAD><TITLE><%= pageTitle %></TITLE>
	<SCRIPT>

		var pageContext="<%=imReq.m_context%>";

		function callBackParent(inputID, inputVal, dispValues) {
			<%if (callBackFunc != null) {%>
				<%=callBackFunc%>(inputID, inputVal, dispValues);
			<%} else {%>
			if(!window.opener.closed) {
				window.opener.applySelectedValue(inputID, inputVal, dispValues);
				<%if (adjustQuery != null && adjustQuery.length() > 0) {%>
				window.opener.updateOtherFields(inputVal, '<%=adjustQuery%>');
				<%}%>
				<%if (doRefresh) {%>
				window.opener.refresh(window.opener.document.saveForm, "<%=FieldPointer.FORMFIELDPREFIX%>" + inputID);
				<%}%>
			}
			window.close();
			<% } %>
		}

		function callBackParentMulti() {
			if(!window.opener.closed) {
				modified=false;
				var i;
			  for (i = 0; i<document.Batch.length; i++) {
    			if (document.Batch.elements[i].name == 'cGr' && document.Batch.elements[i].checked) {
    				modified=true;
						window.opener.writeHiddenInput("saveForm", "cID", document.Batch.elements[i].value);
					}
		  	}
		  	if (modified) {
					window.opener.writeHiddenInput("saveForm", "cFIDColid", "<%=targetField%>");
					window.opener.doSubmit(window.opener.document.saveForm,'<%=operName%>');
				}
			}
			window.close();
		}
  </script>
	
<%
	TabToolbox.writeIMpopup( jspSess.m_out );
	table.printScript( tparams, jspSess, new String[]{} );
//	String filtersLink = filtersTopCell.getLink( is ) + "&cLayoutType=" +parLayoutType + "&cCancelClose=true&cFieldFocus=true";
%>

</HEAD>
<BODY><!-- %=(doFiltersFirst?" onLoad='document.location.href=\""+filtersLink+"\"'":"") % -->
<CENTER>
<%
	if (!doFiltersFirst) {
		TabBean.writeStyleOnly( jspSess.m_out );

	  	table.printTableTop( jspSess );
  		table.print( jspSess );
	}
%>
</CENTER>

</BODY></HTML>