<%@page import="imagemed.layout.macro.complex.ReportButtonsMacro"%>
<%@page import="com.erad.pacs.toolbox.ListToolbox"%>
<%@page import="com.erad.pacs.modules.gwt.datastructure.list.ViewerContext"%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade"%>
<%@page import="com.erad.pacs.services.akac.Akac"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.common.libs.RequestInfo"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.IMRedirectedException"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@
	page errorPage="../main/exceptionHandler.jsp"

%>
<%--
 ** Component: cases
 **
 ** Description:
 **  Handles the redictation process.
 **
 **  @param cGr               		Study Instance UID of study
 **  @param int0_sopiuid      		sopiuid of the interpretation to be redictated
 **  @param int0_typeid       		typeid of the interpretation to be redirected
 **  @param batch_approve_context	context to be updated and used in the backURL if we are called from batchApprove
 **  @param cIMLockID		 					lock ID of the study
 **  @param cOp										operation code ('Redictate')
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@
	page import = "imagemed.util.*, imagemed.exception.*,imagemed.http.*,java.util.*,java.sql.*,
			 imagemed.imsession.*, imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess;
	try {
		sess = userManager.getSessitaSession( request, response );
	}
	catch (IMRedirectedException re) {
		return;
	}
	RequestInfo requestInfo = new RequestInfo(request);


  	if ( !sess.getRights().hasRight( PacsRight.Report ) ) {
		throw new IMException("You don't have the right to redictate reports");
	}
	
	String study = request.getParameter("cGr");
	String sopiuid = request.getParameter("int0_sopiuid");
	String typeid = request.getParameter("int0_typeid");
	String batchContext = request.getParameter("batch_approve_context");
	String reportBackURL = request.getParameter("cBack");
	String loginBackURL = "/cases/reportview.jsp?cGr="+study+"&cBack="+Helper.URLEncodeUTF8(reportBackURL);
	boolean shouldConfirm=false;
	
	if ( !shouldConfirm ) {
		// lock the study if needed...
		String lockID = IMLock.getLockIDFromRequest( sess, request, null ); 
		boolean lockIsValid = AkacFacade.isLockIdValid( sess, study, lockID );
		if ( !lockIsValid ) {
			lockID = AkacFacade.lockStudy( sess, study );
			if ( lockID == null ) {
				// locked by someone else...
				// how about breaking the lock?
				Helper.DEBUG("redirect.jsp", "the study is locked by someone else...");
				return;
			}
		}
		//Helper.DEBUG("redictate.jsp", ""+is.sessionVariables+" "+lockID);
		//is.sessionVariables.setProperty("IMLockID", prpLock.getProperty("IMLockID"));
		ReportToolbox.doCorrect(sess, study, sopiuid, typeid, true, lockID);
		if ( batchContext != null && batchContext.length() > 0 ) {
			Context context = new Context( sess, batchContext );
			String[] parRPIDs = context.getValues( "cRPID" );
			//Helper.writeTextFile("/tmp/redictate.jsp."+batchContext+".debug.txt", imrTmp.toString());
			String[] selectedRPIDs = context.getValues( "cSelectedRPs" );
	  		String currentID = context.getValue( "cCurrentID" );
			List<String> rpidList = new ArrayList<String>();
			rpidList.addAll( Arrays.asList( parRPIDs ) );
			List<String> selRpidList = new ArrayList<String>();
			selRpidList.addAll( Arrays.asList( selectedRPIDs ) );
			int n = rpidList.indexOf( currentID );
			int newCurrentIndex = -1;
			if ( n < rpidList.size() - 1 ) {
				newCurrentIndex = n + 1;
			}
			else if ( n > 0 ) {
				newCurrentIndex = n - 1;
			}
			if ( newCurrentIndex > -1 ) {
				String newCurrent = rpidList.get(newCurrentIndex);
				context.setValue("cCurrentID", newCurrent);
				rpidList.remove(currentID);
				context.setValues("cRPID", rpidList.toArray(new String[0]));
				selRpidList.remove(currentID);
				context.setValues("cSelectedRPs", selRpidList.toArray(new String[0]));
				context.save();
				
				ResultSet rs = IMEnv.getDB().createStatement().executeQuery("select SRCSTUDY,INTID from "+IMEnvBase.getEnv("REPORTTBL")+" where INTSOPIUID='"+newCurrent+"'");
				if (!rs.first()) {
					throw new IMException("Something nasty has happened around the database. (the reportpart "+newCurrent+" has disappeared)");
				}
				String newIntid = rs.getString("INTID");
				loginBackURL = "/cases/reportview.jsp?cContext="+batchContext+"&cOp=batchApprove&cGr="+study+
					"&cIntID="+newIntid+"#section_"+newIntid;
			}
			else { // only one of the batch oper is to be removed...
				loginBackURL = context.getValue( "cBack" );
				context.deleteContextFile();
			}
		}
	}
%>
<html>
<body>
<iframe src=<%=ReportButtonsMacro.getDictationUrl( sess, new RequestInfo( request ), study )%>></iframe>
<script>
setTimeout( function(){ window.location.href = "<%=loginBackURL%>"; }, 300);
</script>
</body>
</html>